	;	abs(i) returns the absolute value of i
	
	
	
	
_abs:
	pop	de	;Return address
	pop	hl
	push	hl
	push	de
	bit	7,h	;Negative?
	ret	z	;no, leave alone
	ex	de,hl
	ld	hl,0
	or	a	;Clear carry
	sbc	hl,de
	ret
	;	arithmetic long left shift
	;	value in HLDE, count in B
	
	
	
	
allsh:
lllsh:
	ld	a,b	;check for zero shift
	or	a
	ret	z
	cp	33
	jr	c,allshlb1	;limit shift to 32 bits
	ld	b,32
allshlb1:
	ex	de,hl
	add	hl,hl
	ex	de,hl 
	adc	hl,hl
	djnz	allshlb1
	ret
	;	arithmetic long right shift
	;	value in HLDE, count in B
	
	
	
	
alrsh:
	ld	a,b	;check for zero shift
	or	a
	ret	z
	cp	33
	jr	c,alrshlb1	;limit shift to 32 bits
	ld	b,32
alrshlb1:
	sra	h
	rr	l
	rr	d
	rr	e
	djnz	alrshlb1
	ret
	;	ASsign Arithmetic Long Left  SHift
	;	ASsign Logical Long Left SHift
	
	
	
	
asallsh:
aslalsh:
	push	bc	;save the count
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	(sp),hl	;save pointer, restore count
	push	bc	;hi word
	ex	(sp),hl
	pop	bc
	call	allsh	;do the shift
	jp	iregstore	;go store the value and return
	;	ASsign Arithmetic Long Right  SHift
	
	
	
	
asalrsh:
	push	bc	;save the count
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	(sp),hl	;save pointer, restore count
	push	bc	;hi word
	ex	(sp),hl
	pop	bc
	call	alrsh	;do the shift
	jp	iregstore	;go store the value and return
	;	Shift operations - the count is always in B,
	;	the quantity to be shifted is in HL, except for the assignment
	;	type operations, when it is in the memory location pointed to by
	;	HL
	
	
	
	
	
	
asar:
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	push	hl	;save for the store
	ex	de,hl
	call	shar
	ex	de,hl
	pop	hl
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	;	Assign versions of divide
	
	
	
	
	
asadiv:
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	ex	(sp),hl
	call	adiv
	ex	(sp),hl
	pop	de
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	
asldiv:
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	ex	(sp),hl
	call	ldiv
	ex	(sp),hl
	pop	de
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	
	
	
	
asaladd:
aslaadd:
	call	iregset
	call	aladd
	jp	iregstore
	
	
	
asaland:
aslaand:
	call	iregset
	call	aland
	jp	iregstore
	;	Shift operations - the count is always in B,
	;	the quantity to be shifted is in HL, except for the assignment
	;	type operations, when it is in the memory location pointed to by
	;	HL
	
	
	
	
	
	
asla:
asal:
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	push	hl	;save for the store
	ex	de,hl
	call	shal
	ex	de,hl
	pop	hl
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	;	ASsign Logical Long Right  SHift
	
	
	
	
aslarsh:
	push	bc	;save the count
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	(sp),hl	;save pointer, restore count
	push	bc	;hi word
	ex	(sp),hl
	pop	bc
	call	llrsh	;do the shift
	jp	iregstore	;go store the value and return
	
	
	
asalmul:
aslamul:
	call	iregset
	call	almul
	jp	iregstore
	
	
	
asalor:
aslaor:
	call	iregset
	call	alor
	jp	iregstore
	;	Shift operations - the count is always in B,
	;	the quantity to be shifted is in HL, except for the assignment
	;	type operations, when it is in the memory location pointed to by
	;	HL
	
	
	
	
	
	
aslr:
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	push	hl	;save for the store
	ex	de,hl
	call	shlr
	ex	de,hl
	pop	hl
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	
	
	
asalsub:
aslasub:
	call	iregset
	call	alsub
	jp	iregstore
	
	
	
asalxor:
aslaxor:
	call	iregset
	call	alxor
	jp	iregstore
	;	Assign versions of modulus
	
	
	
	
	
asamod:
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	ex	(sp),hl
	call	amod
	ex	(sp),hl
	pop	de
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	
aslmod:
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	ex	(sp),hl
	call	lmod
	ex	(sp),hl
	pop	de
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	
	;	Assign versions of multiply
	
	
	
	
	
asamul:
aslmul:
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	ex	(sp),hl
	call	amul
	ex	(sp),hl
	pop	de
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ex	de,hl	;return value in hl
	ret
	
	
digit:	sub	'0'
	ret	c
	cp	10
	ccf
	ret
	
	
_atoi:	pop	bc	;return address
	pop	de
	push	de
	push	bc
	ld	hl,0
atoilb1:
	ld	a,(de)
	inc	de
	cp	' '
	jr	z,atoilb1
	cp	'	'	;tab
	jr	z,atoilb1
	dec	de	;point to 1st non blank char
	cp	'-'
	jr	z,atoilb3
	cp	'+'
	jr	nz,atoilb2
	or	a	;reset zero flag
atoilb3:
	inc	de
atoilb2:	ex	af,af'
atoilb1:
	ld	a,(de)
	inc	de
	call	digit
	jr	c,atoilb3
	add	hl,hl
	ld	c,l
	ld	b,h
	add	hl,hl
	add	hl,hl
	add	hl,bc
	ld	c,a
	ld	b,0
	add	hl,bc
	jr	atoilb1
	
atoilb3:
	ex	af,af'
	ret	nz
	ex	de,hl
	ld	hl,0
	sbc	hl,de
	ret
;	Functions to implement bitfields:
	
	;	the width and offset (in bits) of the bitfield concerned
	;	appear in the code immediately after the call, packed into one byte
;	like this:
	
	;	bit	|7    4|3   0|
	;		|offset|width|
	
;	bfext: called with a value in HL, returns with extracted
	;	bitfield value in HL
	
	
	
bfext:
	pop	bc	;get return address
	ld	a,(bc)	;pick up width and offset
	inc	bc
	push	bc
	push	af
	rra
	rra
	rra
	rra
	and	0Fh	;get offset
	jr	z,bitfieldlb1	;skip if zero
	ld	b,a
bitfieldlb2:
	srl	h
	rr	l
	djnz	bitfieldlb2
bitfieldlb1:
	pop	af
	push	de	;don't touch de
	ld	de,1	;start with a 1
	and	0Fh	;get width
	ld	b,a	;put in counter
bitfieldlb2:
	sla	e
	rl	d	;shift up one bit
	djnz	bitfieldlb2
	dec	de	;decrement by one
	ld	a,l
	and	e	;mask appropriately
	ld	l,a
	ld	a,h
	and	d
	ld	h,a	;all done!
	pop	de
	ret
	
	;	Insert the data in de into the data at (hl). Size and offset
	;	are in the following byte as usual
	
bfins:
	pop	bc	;get return address
	ld	a,(bc)	;get info byte
	inc	bc
	push	bc
	push	hl	;save address
	push	af	;save for ron
	ld	hl,1
	and	0Fh
	ld	b,a
bitfieldlb2:
	sla	l
	rl	h	;shift up one bit
	djnz	bitfieldlb2
	dec	hl	;convert to a mask
	ld	a,e
	and	l
	ld	e,a
	ld	a,d
	and	h
	ld	d,a	;masked it
	pop	af	;get byte again
	push	de	;save value
	rra
	rra
	rra
	rra
	and	0Fh	;mask out offset
	jr	z,bitfieldlb1	;skip if zero
	ld	b,a
bitfieldlb2:
	sla	l	;shift it up
	rl	h
	sla	e
	rl	d
	djnz	bitfieldlb2	;loop for more
bitfieldlb1:
	ex	(sp),hl	;save mask, get value
	pop	bc	;mask in bc
	ex	(sp),hl	;address in hl, save value
	ld	a,c	;complement mask
	cpl
	and	(hl)	;and with memory data
	or	e	;or with shifted value
	ld	(hl),a	;put back
	inc	hl
	ld	a,b
	cpl
	and	(hl)
	or	d
	ld	(hl),a
	pop	hl	;get value back
	ret		;finito!
	;	blkclr(ptr, size)
	;	char *	ptr; unsigned short size;
	
	;	Fills memory with size null bytes
	
	
	
	
_blkclr:
	pop	de	;return address
	pop	hl	;pointer
	pop	bc	;count
	push	bc	;adjust stack
	push	hl
	push	de
	ld	e,0
	
blkclrlb1:
	ld	a,c	;check for finished
	or	b
	ret	z
	ld	(hl),e
	inc	hl
	dec	bc
	jr	blkclrlb1
	;	bmove(from, to, count)
	
	
	
	
_movmem:
_bmove:
	pop	hl	;return address
	exx
	pop	hl	;from
	pop	de	;to
	pop	bc	;count
	ld	a,b
	or	c
	jr	z,bmovelb1
	ldir
bmovelb1:
	push	bc	;stack is as it was
	push	de
	push	hl
	exx
	jp	(hl)
	;	byte relational	operation - returns flags correctly for
	;	comparision of words in a and c
	
	
	
	
brelop:
	push	de
	ld	e,a
	xor	b	;compare signs
	jp	m,breloplb1	;if different, return sign of lhs
	ld	a,e
	sbc	a,b
	pop	de
	ret
breloplb1:
	ld	a,e	;get sign of lhs
	and	80h	;mask out sign flag
	ld	d,a
	ld	a,e
	sbc	a,b	;set carry flag if appropriate
	ld	a,d
	inc	a	;set sign flag as appropriate and reset Z flag
	pop	de
	ret
	
	
csv:	pop	hl	;return address
	push	iy
	push	ix
	ld	ix,0
	add	ix,sp	;new frame pointer
	jp	(hl)
	
cret:	ld	sp,ix
	pop	ix
	pop	iy
	ret
	
indir:	jp	(hl)
	
;	New csv: allocates space for stack based on word following
	;	call ncsv
	
ncsv:
	pop	hl
	push	iy
	push	ix
	ld	ix,0
	add	ix,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ex	de,hl
	add	hl,sp
	ld	sp,hl
	ex	de,hl
	jp	(hl)
	;	floating relational operation - returns flags as though
	;	a floating subtract was done.
	
	
	
	
frelop:
	exx		;select	alternate reg set
	pop	hl	;return	address
	exx		;get other set again
	pop	bc	;low word of 2nd arg
	ex	de,hl	;put hi	word of	1st in de
	ex	(sp),hl	;get hi	word of	2nd in hl
	ex	de,hl	;hi word of 1st	back in	hl
	ld	a,h	;test for differing signs
	xor	d
	jp	p,freloplb2	;the same, so ok
	ld	a,h	;get the sign of the LHS
	or	1	;ensure zero flag is reset, set sign flag
	pop	bc	;unjunk stack
	jp	freloplb1	;return	with sign of LHS
freloplb2:
	ld	a,h	;test for differing exponents
	sub	d	;compare with the other
	jr	z,freloplb2	;the same, go for mantissas
	xor	h	;complement sign flag if operands -ve
	or	1	;reset zero flag
	pop	bc	;unjunk stack
	jp	freloplb1	;and return
freloplb2:
	or	a
	sbc	hl,de	;set the flags
	pop	hl	;low word of 1st into hl again
	jr	nz,freloplb1	;go return if not zero
	sbc	hl,bc	;now set flags on basis	of low word
	jr	z,freloplb1	;if zero, all ok
	ld	a,2	;make non-zero
	rra		;rotate	carry into sign
	or	a	;set minus flag
	rlca		;put carry flag	back
	
freloplb1:
	exx		;get return address
	jp	(hl)	;and return with stack clean
	;	Return value of the stack pointer
	
	
	
__getsp:
	ld	hl,0
	add	hl,sp
	ret
	;	16 bit divide and modulus routines
	
	;	called with dividend in hl and divisor in de
	
	;	returns with result in hl.
	
	;	adiv (amod) is signed divide (modulus), ldiv (lmod) is unsigned
	
	
	
	
amod:
	call	adiv
	ex	de,hl	;put modulus in hl
	ret
	
lmod:
	call	ldiv
	ex	de,hl
	ret
	
ldiv:
	xor	a
	ex	af,af'
	ex	de,hl
	jr	dv1
	
	
adiv:
	ld	a,h
	xor	d	;set sign flag for quotient
	ld	a,h	;get sign of dividend
	ex	af,af'
	call	negif
	ex	de,hl
	call	negif
dv1:	ld	b,1
	ld	a,h
	or	l
	ret	z
dv8:	push	hl
	add	hl,hl
	jr	c,dv2
	ld	a,d
	cp	h
	jr	c,dv2
	jp	nz,dv6
	ld	a,e
	cp	l
	jr	c,dv2
dv6:	pop	af
	inc	b
	jp	dv8
	
dv2:	pop	hl
	ex	de,hl
	push	hl
	ld	hl,0
	ex	(sp),hl
	
dv4:	ld	a,h
	cp	d
	jr	c,dv3
	jp	nz,dv5
	ld	a,l
	cp	e
	jr	c,dv3
	
dv5:	sbc	hl,de
dv3:	ex	(sp),hl
	ccf
	adc	hl,hl
	srl	d
	rr	e
	ex	(sp),hl
	djnz	dv4
	pop	de
	ex	de,hl
	ex	af,af'
	call	m,negat
	ex	de,hl
	or	a		;test remainder sign bit
	call	m,negat
	ex	de,hl
	ret
	
negif:	bit	7,h
	ret	z
negat:	ld	b,h
	ld	c,l
	ld	hl,0
	or	a
	sbc	hl,bc
	ret
	;	16 bit integer multiply
	
	;	on entry, left operand is in hl, right operand in de
	
	
	
amul:
lmul:
	ld	a,e
	ld	c,d
	ex	de,hl
	ld	hl,0
	ld	b,8
	call	mult8b
	ex	de,hl
	jr	imullb3
imullb2:	add	hl,hl
imullb3:
	djnz	imullb2
	ex	de,hl
imullb1:
	ld	a,c
mult8b:
	srl	a
	jp	nc,imullb1
	add	hl,de
imullb1:	ex	de,hl
	add	hl,hl
	ex	de,hl
	ret	z
	djnz	mult8b
	ret
	
	
	
_index:	call	rcsv
	
	jr	indexlb3
indexlb1:
	inc	hl
indexlb3:
	ld	a,(hl)
	or	a
	jr	z,indexlb2
	cp	e
	jr	nz,indexlb1
indexlb4:	jp	cret
	
indexlb2:	ld	hl,0
	jp	indexlb4
	
	
	
_in:
_inp:
	pop	hl	;return address
	pop	bc	;port address
	push	bc
	push	hl
	in	l,(c)	;read port
	ld	h,0	;zero extend it
	ret
	
_out:
_outp:
	pop	hl	;return address
	pop	bc	;port address
	pop	de	;data
	push	de
	push	bc
	push	hl
	out	(c),e	;output the data
	ld	l,c	;return value in hl also
	ld	h,0
	ret
	;	routines to support the assignment versions of the long operations
	
	
	
	
iregset:
	ld	e,(hl)	;pick up arg
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	(sp),hl	;save pointer, get return address
	push	bc	;now put the hi word into hl
	ex	(sp),hl	;saving return address on stack again
	pop	bc	;now return address in bc
	exx
	pop	hl	;the pointer
	pop	bc	;the final return address
	pop	de	;now the low word of arg2
	ex	(sp),hl	;get the hi word, save pointer
	push	bc	;this is the return address again
	ex	(sp),hl	;into hl again
	pop	bc	;hi word now in bc
	ex	(sp),hl	;AHA! got return address on stack, ptr in hl
	push	hl	;now its easy, save pointer
	push	bc	;hi word
	push	de	;low word
	exx
	push	bc	;immediate return address
	ret	;finito
	
iregstore:
	ex	(sp),hl	;get pointer into hl
	pop	bc	;hi word in bc
	ld	(hl),b
	dec	hl
	ld	(hl),c
	dec	hl
	ld	(hl),d
	dec	hl
	ld	(hl),e	;all done
	push	bc	;restore to hl
	pop	hl
	ret	;and return with value in hl
	
	
	
_isalpha:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	jr	nz,nix
	ld	a,l
	cp	'A'
	jr	c,nix
	cp	'z'+1
	jr	nc,nix
	cp	'a'
	cp	'Z'+1
	jr	c,yes
	cp	'a'
	jr	c,nix
yes:
	ld	hl,1	;yes
	ret
nix:	ld	hl,0
	ret
	
	
	
_isdigit:
_isdig:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	jr	nz,nix
	ld	a,l
	cp	'0'
	jr	c,nix
	cp	'9'+1
	jr	nc,nix
	ld	hl,1	;yes
	ret
nix:	ld	hl,0
	ret
	
	
	
_islower:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	jr	nz,nix
	ld	a,l
	cp	'a'
	jr	c,nix
	cp	'z'+1
	jr	nc,nix
	ld	hl,1	;yes
	ret
nix:	ld	hl,0
	ret
	
	
	
_isspace:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	jr	nz,nix
	ld	a,l
	cp	' '
	jr	z,yes
	cp	12	;newline
	jr	z,yes
	cp	9	;tab
	jr	nz,nix
yes:
	ld	hl,1	;yes
	ret
nix:	ld	hl,0
	ret
	
	
	
_isupper:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	jr	nz,nix
	ld	a,l
	cp	'A'
	jr	c,nix
	cp	'Z'+1
	jr	nc,nix
	ld	hl,1	;yes
	ret
nix:	ld	hl,0
	ret
	
	
	
aladd:
lladd:
	exx
	pop	hl
	exx
	pop	bc
	ex	de,hl
	add	hl,bc
	ex	de,hl
	pop	bc
	adc	hl,bc
	exx
	push	hl
	exx
	ret
	
	
	
aland:
lland:
	exx
	pop	hl
	exx
	pop	bc
	ld	a,c
	and	e
	ld	e,a
	ld	a,b
	and	d
	ld	d,a
	pop	bc
	ld	a,c
	and	l
	ld	l,a
	ld	a,b
	and	h
	ld	h,a
	exx
	push	hl
	exx
	ret
	;	Long division routines for Z80
	
	
	
	
	
	
	
	;	Called with dividend in HLDE, divisor on stack under 2 return
	;	addresses. Returns with dividend in HL/HL', divisor in DE/DE'
	;	on return the HIGH words are selected.
	
lregset:
	pop	bc		;get top return address
	exx		;select other bank
	pop	bc		;return address of call to this module
	pop	de		;get low word of divisor
	exx		;select hi bank
	ex	de,hl		;dividend.low -> hl
	ex	(sp),hl		;divisor.high -> hl
	ex	de,hl		;dividend.high -> hl
	exx		;back to low bank
	push	bc		;put outer r.a. back on stack
	pop	hl		;return address
	ex	(sp),hl		;dividend.low -> hl
	exx
	push	bc		;top return address
	ret
	
	;	Much the same as lregset, except that on entry the dividend
	;	is pointed to by HL.
	;	The pointer is saved in iy for subsequent updating of memory
	
iregset:
	pop	de		;immediate return address
	call	lregset		;returns with hi words selected
	push	hl		;save a copy for 'ron
	ex	(sp),iy		;get it in iy, saving old iy
	ld	h,(iy+3)	;high order byte
	ld	l,(iy+2)	;byte 2
	exx		;back to low bank
	push	hl		;return address
	ld	h,(iy+1)	;byte 1
	ld	l,(iy+0)	;and LSB
	exx		;restore hi words
	ret		;now return
	
	;	Called with hi words selected, performs division on the absolute
	;	values of the dividend and divisor. Quotient is positive
	
sgndiv:
	call	negif		;make dividend positive
	exx
	ex	de,hl		;put divisor in HL/HL'
	exx
	ex	de,hl
	call	negif		;make divisor positive
	ex	de,hl		;restore divisor to DE/DE'
	exx
	ex	de,hl
	exx		;select high words again
	jp	divide		;do division
	
asaldiv:
	call	iregset
	call	dosdiv
store:
	ld	(iy+0),e
	ld	(iy+1),d
	ld	(iy+2),l
	ld	(iy+3),h
	pop	iy		;restore old iy
	ret
	
aldiv:	call	lregset		;get args
	
	;	Called with high words selected, performs signed division by
	;	the rule that the quotient is negative iff the signs of the dividend
	;	and divisor differ
	;	returns quotient in HL/DE
	
dosdiv:
	ld	a,h
	xor	d
	ex	af,af'		;sign bit is now sign of quotient
	call	sgndiv		;do signed division
	ex	af,af'		;get sign flag back
	push	bc		;high word
	exx
	pop	hl
	ld	e,c		;low word of quotient
	ld	d,b
	jp	m,negat		;negate quotient if necessary
	ret
	
lldiv:	call	lregset
	
	;	Called with high words selected, performs unsigned division
	;	returns with quotient in HL/DE
	
doudiv:
	call	divide		;unsigned division
	push	bc		;high word of quotien
	exx
	pop	hl
	ld	e,c		;low word
	ld	d,b
	ret
	
asladiv:
	call	iregset
	call	doudiv
	jp	store
	
	
almod:
	call	lregset
	
	;	Called with high words selected, performs signed modulus - the rule
	;	is that the sign of the remainder is the sign of the dividend
	
dosrem:
	ld	a,h		;get sign of dividend
	ex	af,af'		;save it
	call	sgndiv		;do signed division
	push	hl		;high word
	exx
	pop	de
	ex	de,hl		;put high word in hl
	ex	af,af'		;get sign bit back
	or	a
	jp	m,negat		;negate if necessary
	ret
	
asalmod:
	call	iregset
	call	dosrem
	jp	store
	
llmod:
	call	lregset
	
	;	Called with high words selected, perform unsigned modulus
	
dourem:
	call	divide
	push	hl		;high word of remainder
	exx
	pop	de
	ex	de,hl		;high word in hl
	ret
	
aslamod:
	call	iregset
	call	dourem
	jp	store
	
	;	Negate the long in HL/DE
	
negat:	push	hl		;save high word
	ld	hl,0
	or	a
	sbc	hl,de
	ex	de,hl
	pop	bc		;get high word back
	ld	hl,0
	sbc	hl,bc
	ret		;finito
	
negif:	;called with high word in HL, low word in HL'
	;returns with positive value
	
	bit	7,h		;check sign
	ret	z		;already positive
	exx		;select low word
	ld	c,l
	ld	b,h
	ld	hl,0
	or	a
	sbc	hl,bc
	exx
	ld	c,l
	ld	b,h
	ld	hl,0
	sbc	hl,bc
	ret		;finito
	
	;	Called with dividend in HL/HL', divisor in DE/DE', high words in
	;	selected register set
	;	returns with quotient in BC/BC', remainder in HL/HL', high words
	;	selected
	
divide:
	ld	bc,0		;initialize quotient
	ld	a,e		;check for zero divisor
	or	d
	exx
	ld	bc,0
	or	e
	or	d
	exx		;restor high words
	ret	z		;return with quotient == 0
	ld	a,1		;loop count
	jp	ldivlb3		;enter loop in middle
ldivlb1:
	push	hl		;save divisor
	exx
	push	hl		;low word
	or	a		;clear carry
	sbc	hl,de		;subtract low word
	exx
	sbc	hl,de		;sbutract hi word
	exx
	pop	hl		;restore dividend
	exx
	pop	hl		;and hi word
	jr	c,ldivlb2		;finished - divisor is big enough
	exx
	inc	a		;increment count
	ex	de,hl		;put divisor in hl - still low word
	add	hl,hl		;shift left
	ex	de,hl		;put back in de
	exx		;get hi word
	ex	de,hl
	adc	hl,hl		;shift with carry
	ex	de,hl
ldivlb3:
	bit	7,d		;test for max divisor
	jp	z,ldivlb1		;loop if msb not set
	
ldivlb2:	;arrive here with shifted divisor, loop count in a, and low words
	;selected
	
	
ldivlb3:
	push	hl		;save dividend
	exx
	push	hl		;low word
	or	a		;clear carry
	sbc	hl,de
	exx
	sbc	hl,de
	exx		;restore low word
	jp	nc,ldivlb4
	pop	hl		;restore low word of dividend
	exx
	pop	hl		;hi word
	exx		;restore low word
	jr	ldivlb5
ldivlb4:
	inc	sp		;unjunk stack
	inc	sp
	inc	sp
	inc	sp
ldivlb5:
	ccf		;complement carry bit
	rl	c		;shift in carry bit
	rl	b		;next byte
	exx		;hi word
	rl	c
	rl	b
	srl	d		;now shift divisor right
	rr	e
	exx		;get low word back
	rr	d
	rr	e
	exx		;select hi word again
	dec	a		;decrement loop count
	jr	nz,ldivlb3
	ret		;finished
	;	Long increment
	
	
	
	
	
gval:
	exx
	pop	hl	;return address
	exx
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	de	;lo word
	push	bc	;hi word
	push	bc
	ex	(sp),hl
	exx
	push	hl	;return address
	exx
	ret
	
lainc:
llinc:
	call	gval
	ld	bc,1
	ex	de,hl
	add	hl,bc
	ex	de,hl
	ld	c,0
	adc	hl,bc
	
sval:
	ex	(sp),hl
	pop	bc
	ld	(hl),b
	dec	hl
	ld	(hl),c
	dec	hl
	ld	(hl),d
	dec	hl
	ld	(hl),e
	pop	hl	;restore original value
	pop	de
	ret
	
lldec:
ladec:
	call	gval
	ld	bc,-1
	ex	de,hl
	add	hl,bc
	ex	de,hl
	adc	hl,bc
	jr	sval
	;	logical long right shift
	;	value in HLDE, count in B
	
	
	
	
llrsh:
	ld	a,b	;check for zero shift
	or	a
	ret	z
	cp	33
	jr	c,llrshlb1	;limit shift to 32 bits
	ld	b,32
llrshlb1:
	srl	h
	rr	l
	rr	d
	rr	e
	djnz	llrshlb1
	ret
	;	Long multiplication for Z80
	
	;	Called with 1st arg in HLDE, 2nd arg on stack. Returns with
	;	result in HLDE, other argument removed from stack
	
	
	
	
almul:
llmul:
	ex	de,hl
	ex	(sp),hl	;return address now in hl
	exx
	pop	de	;low word in de
	pop	bc	;low word of multiplier in bc
	exx
	pop	bc	;hi word of multiplier
	push	hl	;restore return address
	ld	hl,0	;initialize product
	exx		;get lo words back
	ld	hl,0
	ld	a,c
	ld	c,b
	call	mult8b
	ld	a,c
	call	mult8b
	exx
	ld	a,c
	exx
	call	mult8b
	exx
	ld	a,b
	exx
	call	mult8b
	push	hl	;low word
	exx
	pop	de
	ret
	
mult8b:	ld	b,8
lmullb3:
	srl	a
	jp	nc,lmullb1
	add	hl,de
	exx
	adc	hl,de
	exx
lmullb1:	ex	de,hl
	add	hl,hl
	ex	de,hl
	exx
	ex	de,hl
	adc	hl,hl
	ex	de,hl
	exx
	djnz	lmullb3
	ret
	;	setjump, longjump - non local goto
	
	
	
	
_setjmp:
	pop	bc	;return address
	ex	(sp),iy
	pop	de
	push	iy
	ld	hl,0
	add	hl,sp
	ld	(iy+0),l
	ld	(iy+1),h
	push	ix
	pop	hl
	ld	(iy+2),l
	ld	(iy+3),h
	ld	(iy+4),c
	ld	(iy+5),b
	ld	(iy+6),e
	ld	(iy+7),d
	push	bc
	ld	hl,0	;setjmp returns 0
	push	de	;restore iy
	pop	iy
	ret
	
_longjmp:
	pop	bc	;return address - junk now
	pop	iy	;argument
	pop	de	;and return value
	ld	l,(iy+0)
	ld	h,(iy+1)
	ld	sp,hl		;stack pointer
	ld	l,(iy+2)
	ld	h,(iy+3)
	push	hl
	pop	ix
	ld	l,(iy+4)
	ld	h,(iy+5)
	ld	c,(iy+6)
	ld	b,(iy+7)
	push	bc
	pop	iy
	push	hl
	ex	de,hl	;get arg into hl
	ret
	
	
	
alor:
llor:
	exx
	pop	hl
	exx
	pop	bc
	ld	a,c
	or	e
	ld	e,a
	ld	a,b
	or	d
	ld	d,a
	pop	bc
	ld	a,c
	or	l
	ld	l,a
	ld	a,b
	or	h
	ld	h,a
	exx
	push	hl
	exx
	ret
	;	long relational	operation - returns flags as though
	;	a long subtract	was done.
	
	
	
	
arelop:
lrelop:
	exx		;select	alternate reg set
	pop	hl	;return	address
	exx		;get other set again
	pop	bc	;low word of 2nd arg
	ex	de,hl	;put hi	word of	1st in de
	ex	(sp),hl	;get hi	word of	2nd in hl
	ex	de,hl	;hi word of 1st	back in	hl
	ld	a,h	;test for differing signs
	xor	d
	jp	p,lreloplb2	;the same, so ok
	ld	a,h	;get the sign of the LHS
	or	1	;ensure zero flag is reset, set sign flag
	pop	hl	;unjunk stack
	jp	lreloplb1	;return	with sign of LHS
lreloplb2:
	or	a
	sbc	hl,de	;set the flags
	pop	hl	;low word of 1st into hl again
	jr	nz,lreloplb1	;go return if not zero
	sbc	hl,bc	;now set flags on basis	of low word
	jr	z,lreloplb1	;if zero, all ok
	ld	a,2	;make non-zero
	rra		;rotate	carry into sign
	or	a	;set minus flag
	rlca		;put carry flag	back
	
lreloplb1:
	exx		;get return address
	jp	(hl)	;and return with stack clean
	
	
	
alsub:
llsub:
	exx
	pop	hl
	exx
	pop	bc
	ex	de,hl
	or	a
	sbc	hl,bc
	ex	de,hl
	pop	bc
	sbc	hl,bc
	exx
	push	hl
	exx
	ret
	
	
	
alxor:
llxor:
	exx
	pop	hl
	exx
	pop	bc
	ld	a,c
	xor	e
	ld	e,a
	ld	a,b
	xor	d
	ld	d,a
	pop	bc
	ld	a,c
	xor	l
	ld	l,a
	ld	a,b
	xor	h
	ld	h,a
	exx
	push	hl
	exx
	ret
	
	
	
_max:
	pop	bc	;return address
	pop	de	;arg 1
	pop	hl	;arg 2
	push	hl
	push	de
	push	bc
	push	hl	;save it
	or	a	;clear carry
	sbc	hl,de	;compare
	pop	hl	;restore
	ret	nc	;return if greater or equal
	ex	de,hl	;otherwise returnt the other
	ret
	
	
	ARG	equ	6	;offset of 1st arg
	
rcsv:
	ex	(sp),iy	;save iy, get return address
	push	ix
	ld	ix,0
	add	ix,sp	;new frame pointer
	ld	l,(ix+ARG+0)
	ld	h,(ix+ARG+1)
	ld	e,(ix+ARG+2)
	ld	d,(ix+ARG+3)
	ld	c,(ix+ARG+4)
	ld	b,(ix+ARG+5)
	jp	(iy)
	
	
	
_rindex:
	call	rcsv
	
	ld	bc,0
	jr	rindexlb5
rindexlb6:
	inc	hl
	inc	bc
rindexlb5:
	ld	a,(hl)
	or	a
	jr	nz,rindexlb6
rindexlb1:
	dec	hl
	ld	a,c
	or	b
	jr	z,rindexlb2
	dec	bc
	ld	a,(hl)
	cp	e
	jr	nz,rindexlb1
rindexlb4:	jp	cret
	
rindexlb2:	ld	hl,0
	jp	rindexlb4
	
	
	
	;	NB This brk() does not check that the argument is reasonable.
	
_brk:
	pop	hl	;return address
	pop	de	;argument
	ld	(memtop),de	;store it
	push	de	;adjust stack
	jp	(hl)	;return
_sbrk:
	pop	bc
	pop	de
	push	de
	push	bc
	ld	hl,(memtop)
	ld	a,l
	or	h
	jr	nz,sbrklb1
	ld	hl,__Hbss
	ld	(memtop),hl
sbrklb1:
	add	hl,de
	jr	c,sbrklb2	;if overflow, no room
	ld	bc,1024	;allow 1k bytes stack overhead
	add	hl,bc
	jr	c,sbrklb2	;if overflow, no room
	sbc	hl,sp
	jr	c,sbrklb1
sbrklb2:
	ld	hl,-1	;no room at the inn
	ret
	
sbrklb1:	ld	hl,(memtop)
	push	hl
	add	hl,de
	ld	(memtop),hl
	pop	hl
	ret
	
_checksp:
	ld	hl,(memtop)
	ld	bc,128
	add	hl,bc
	sbc	hl,sp
	ld	hl,1	;true if ok
	ret	c	;if carry, sp > memtop+128
	dec	hl	;make into 0
	ret
	
	
memtop:	ds	2
	;	Shift operations - the count is always in B,
	;	the quantity to be shifted is in HL, except for the assignment
	;	type operations, when it is in the memory location pointed to by
	;	HL
	
	
	
	
	
shar:
	ld	a,b	;check for zero shift
	or	a
	ret	z
	cp	16	;16 bits is maximum shift
	jr	c,sharlb1	;is ok
	ld	b,16
sharlb1:
	sra	h
	rr	l
	djnz	sharlb1
	ret
	;	Shift operations - the count is always in B,
	;	the quantity to be shifted is in HL, except for the assignment
	;	type operations, when it is in the memory location pointed to by
	;	HL
	
	
	
	
	
shll:
shal:
	ld	a,b	;check for zero shift
	or	a
	ret	z
	cp	16	;16 bits is maximum shift
	jr	c,shlllb1	;is ok
	ld	b,16
shlllb1:
	add	hl,hl	;shift left
	djnz	shlllb1
	ret
	;	Shift operations - the count is always in B,
	;	the quantity to be shifted is in HL, except for the assignment
	;	type operations, when it is in the memory location pointed to by
	;	HL
	
	
	
	
	
shlr:
	ld	a,b	;check for zero shift
	or	a
	ret	z
	cp	16	;16 bits is maximum shift
	jr	c,shlrlb1	;is ok
	ld	b,16
shlrlb1:
	srl	h
	rr	l
	djnz	shlrlb1
	ret
	
	
	
_strcat:
	pop	bc
	pop	de
	pop	hl
	push	hl
	push	de
	push	bc
	ld	c,e	;save destination pointer
	ld	b,d
	
strcatlb1:	ld	a,(de)
	or	a
	jr	z,strcatlb2
	inc	de
	jr	strcatlb1
	
strcatlb2:	ld	a,(hl)
	ld	(de),a
	or	a
	jr	z,strcatlb3
	inc	de
	inc	hl
	jr	strcatlb2
	
strcatlb3:
	ld	l,c	;restore destination
	ld	h,b
	ret
	
	
	
_strchr:
	call	rcsv
	
	jr	strchrlb3
strchrlb1:
	inc	hl
strchrlb3:
	ld	a,(hl)
	or	a
	jr	z,strchrlb2
	cp	e
	jr	nz,strchrlb1
strchrlb4:	jp	cret
	
strchrlb2:	ld	hl,0
	jp	strchrlb4
	
	
	
_strcmp:	pop	bc
	pop	de
	pop	hl
	push	hl
	push	de
	push	bc
	
strcmplb1:	ld	a,(de)
	cp	(hl)
	jr	nz,strcmplb2
	inc	de
	inc	hl
	or	a
	jr	nz,strcmplb1
	ld	hl,0
	ret
	
strcmplb2:	ld	hl,1
	ret	nc
	dec	hl
	dec	hl
	ret
	
	
	
_strcpy:	pop	bc
	pop	de
	pop	hl
	push	hl
	push	de
	push	bc
	ld	c,e
	ld	b,d	;save destination pointer
	
strcpylb1:	ld	a,(hl)
	ld	(de),a
	inc	de
	inc	hl
	or	a
	jr	nz,strcpylb1
	ld	l,c
	ld	h,b
	ret
	
	
_strlen:	pop	hl
	pop	de
	push	de
	push	hl
	ld	hl,0
	
strlenlb1:	ld	a,(de)
	or	a
	ret	z
	inc	hl
	inc	de
	jr	strlenlb1
	
	
	
_strncat:
	call	rcsv
	push	hl
	
	jr	strncatlb3
strncatlb4:
	inc	hl
strncatlb3:
	ld	a,(hl)
	or	a
	jr	nz,strncatlb4
	
strncatlb1:
	ld	a,c
	or	b
	jr	z,strncatlb3
	dec	bc
	ld	a,(de)
	ld	(hl),a
	inc	hl
	or	a
	jr	z,strncatlb2
	inc	de
	jr	strncatlb1
strncatlb3:
	ld	(hl),0
	
strncatlb2:	pop	hl
	jp	cret
	
	
	
	
_strncmp:
	call	rcsv
	
strncmplb1:	ld	a,c
	or	b
	jp	z,strncmplb3
	dec	bc
	ld	a,(de)
	cp	(hl)
	jr	nz,strncmplb2
	inc	de
	inc	hl
	or	a
	jr	nz,strncmplb1
strncmplb3:
	ld	hl,0
	jp	cret
	
strncmplb2:	ld	hl,1
	jp	c,cret
	dec	hl
	dec	hl
	jp	cret
	
	
	
_strncpy:
	call	rcsv
	push	hl
	
strncpylb1:
	ld	a,c
	or	b
	jr	z,strncpylb2
	dec	bc
	ld	a,(de)
	ld	(hl),a
	inc	hl
	or	a
	jr	z,strncpylb1
	inc	de
	jr	strncpylb1
	
strncpylb2:	pop	hl
	jp	cret
	
	
	
_strrchr:
	call	rcsv
	
	ld	bc,0
	jr	strrchrlb5
strrchrlb6:
	inc	hl
	inc	bc
strrchrlb5:
	ld	a,(hl)
	or	a
	jr	nz,strrchrlb6
strrchrlb1:
	dec	hl
	ld	a,c
	or	b
	jr	z,strrchrlb2
	dec	bc
	ld	a,(hl)
	cp	e
	jr	nz,strrchrlb1
strrchrlb4:	jp	cret
	
strrchrlb2:	ld	hl,0
	jp	strrchrlb4
	;	_swap(width, s1, s2)
	
	;	exchange the two byte arrays
	
	
	
__swap:
	call	rcsv
	push	bc
	ex	(sp),hl
	pop	bc
	jr	swaplb1
swaplb2:
	ld	a,(hl)
	ex	af,af'
	ld	a,(de)
	ld	(hl),a
	ex	af,af'	
	ld	(de),a
	inc	hl
	inc	de
	dec	bc
swaplb1:
	ld	a,b
	or	c
	jr	nz,swaplb2
	jp	cret
	
	
	
_tolower:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	ret	nz
	ld	a,l
	cp	'A'
	ret	c	;Less than a
	cp	'Z'+1
	ret	nc	;More than z
	sub	'A'-'a'
	ld	l,a
	ret
	
	
	
_toupper:
	pop	de	;return address
	pop	hl
	push	hl
	push	de
	ld	a,h	;check for a char
	or	a
	ret	nz
	ld	a,l
	cp	'a'
	ret	c	;Less than a
	cp	'z'+1
	ret	nc	;More than z
	sub	'a'-'A'
	ld	l,a
	ret
	;	word relational	operation - returns flags correctly for
	;	comparision of words in hl and de
	
	
	
	
wrelop:
	ld	a,h
	xor	d	;compare signs
	jp	m,wreloplb1	;if different, return sign of lhs
	sbc	hl,de	;just set flags as normal
	ret
wreloplb1:
	ld	a,h	;get sign of lhs
	and	80h	;mask out sign flag
	sbc	hl,de	;set carry flag if appropriate
	inc	a	;set sign flag as appropriate and reset Z flag
	ret
	
	
hexdig:	cp	'0'
	ret	c
	cp	'9'+1
	jr	nc,xtoilb1
	sub	'0'
	ret
	
xtoilb1:	cp	'A'
	ret	c
	cp	'F'+1
	jr	nc,xtoilb2
	sub	'A'-0Ah
	ret
	
xtoilb2:	cp	'a'
	ret	c
	cp	'f'+1
	ccf
	ret	c
	sub	'a'-0ah
	ret
	
_xtoi:	pop	bc	;return address
	pop	de
	push	de
	push	bc
	ld	hl,0
xtoilb1:
	ld	a,(de)
	inc	de
	call	hexdig
	ret	c
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	c,a
	ld	b,0
	add	hl,bc
	jr	xtoilb1
	
_ishex:	pop	hl
	pop	de
	push	de
	push	hl
	ld	a,e
	ld	hl,0
	call	hexdig
	ret	c
	inc	hl
	ret
