/* Zen stdio.h; actually, all these are syscalls */

#include "zen.h"

/* Minix compatibility */
#define _PROTOTYPE(a,b) a b;
#define perror(X) fprintf(stderr,"error: "X)

extern FILE *fopen(char *name, char *mode);
extern void fclose(FILE *file);
extern void fprintf(FILE *f, char *s, ...);
extern void printf(char *s, ...);
extern char fputc(char c, FILE *f);
extern char fgetc(FILE *f);
extern int fputs(char *s, FILE *f);
extern char *malloc(unsigned nbytes);
extern void free(char *ap);
extern int create(char *n, char t);
extern DIR *opendir(int i);
extern void closedir(DIR *d);
extern DIRENT *readdir(DIR *d);
extern char *dirname(char *name);
extern char *basename(char *name);
extern int mkdir(char *name);
extern char *fgets(char *s, int n, FILE *f);
extern int unlink(char *name);
extern void memcpy(char *a, char *b, int c); /* should be stdlib? */
extern int ln(char *old, char *new); /* should be "link", same syntax */
extern int feof(FILE *f); /* This looks like it should be a define, but
			   isn't, because f gets evaluated twice. */
extern int system(char *cmd);
extern void fflush(FILE *f);

extern FILE *stdout;
extern FILE *stdin;
extern FILE *stderr;

extern int strcmp(char *p, char *q);
extern char *index(char *s, char c);
extern char *rindex(char *s, char c);
extern int strncmp(char *p, char *q, int l);
extern int strlen(char *s);
extern int atoi(char *s);
extern char in(int p);
extern void out(int p,char c);


