# Functions that are used by the c2x.sh files.

emu () {
    echo CPM: $*
    echo unix | cpm $*
    echo
}

defftodb () {
    echo >deff.asm deff $(sed "s/.*deff[ ]*\([-\.e0-9]*\).*/\1/g")
    emu zas deff.asm 2>&1 >/dev/null
    dd if=deff.obj bs=1 skip=20 count=4 2>/dev/null | od -tx1 -An | sed "s/ \(..\) \(..\) \(..\) \(..\)/db 0\1h,0\2h,0\3h,0\4h/g"
}

removedeffs () {
    while read x ; do
	if echo $x | grep -F -q deff ; then
	    echo $x | defftodb
	else
	    echo $x
	fi
    done
}

cltoasm () {
    ./uncpm <$1 | unzasfilter "" `basename $1 .as` >`basename $1 .as`.asm
}

# I do like the software toolbox philosophy. An optimizing linker in
# shell script? You'd better believe it...
cldepend () {
    files="clib/rcsv.asm clib/ladd.asm clib/iregset.asm "
    for x in clib/*.asm ; do
#	echo >&2 -n "[$x] "
	additional=""
	for y in `grep -e "^[_]*[a-z]*:" $x | sed -e "s/^\([^:]*\):.*/\1/g"` ; do
#	    echo >&2 -n "$y "
	    grep -q -w $y $1 && additional=$x
	done
	files="$additional $files"
    done
    files="`(for x in $files ; do echo $x ; done) | sort | uniq`"
    echo >&2 Depends on: $files
    echo $files
}

zastoasl () {
    cat >tmp.$$
    cat aslheader.asm $1 tmp.$$ `cldepend tmp.$$` final.asm | unzasfilter
    rm -f tmp.$$
}

unzasfilter () { 
    sed \
	-e "s/
//g" \
	-e "s/sll/sla/g" \
	-e "s/+-/-/g" \
	-e "s/af,af'/AF,AF\`/g" \
	-e "s/defs/ds/g" \
	-e "s/L\([0123456789]\)/XL\1/g" \
	-e "s/^\([0123456789]\+\):/$2lb\1:/g" \
	-e "s/\([,	]\)\([0123456789]\+\)f/\1$2lb\2/g" \
	-e "s/\([,	]\)\([0123456789]\+\)b/\1$2lb\2/g" \
	-e "s/^[	]*global.*$//g" \
	-e "s/^[	]*psect.*$//g" \
	-e "s/^\([^:]*\)$/	\1/g" \
	-e "s/		/	/g"
}



